import ddf.minim.analysis.*;
import ddf.minim.*;
int num = 1200;
Waves[] wave = new Waves[num];
int j = 0;

AudioPlayer song;
FFT fft;

void setup() {
  size (1024, 800);
  smooth();
  for (int i = 0; i < num; i++){
    wave[i] = new Waves();
  }
  Minim.start(this);
  song = Minim.loadFile("rckmybt.mp3");
  song.loop();
  fft = new FFT(song.mix.size(), 44100);
  fft.logAverages(22, 3);
  frameRate(10);
  
  
}

void draw() {
  noStroke();
  fill(50, 50, 255, 15);
  rect(0, 0, width, height);
  fft.forward(song.mix);
  for(int h = 0; h < num; h ++) {
    wave[h].display();
  }
  house();
  for(int i = 0; i < fft.avgSize(); i++) {
    if (fft.getAvg(i) > 2) {
    wave[j].update(i*40.0, height - fft.getAvg(i)*i - 20, fft.getAvg(i)*i/2);
    if (j< num - 1) j++;
    else j = 0;
    }
   // if (
   }
  
}

class Waves {
  float x;
 float y;
float radius;
int A = 255;
 Waves() {
    
  }
  void update(float tx, float ty, float tradius) {
    x = tx;
    y = ty;
    radius = tradius;
    A = 255;
  }
  void display() {
   pushMatrix();
   fill(A, A, 255);
   translate(x,y);
   ellipse(0, 0, radius, radius);
   popMatrix();
   y -= 20;
   A -= 5;
   radius += 5;
  }
}

void house() {
  for (int g = 0; g < 27; g++) {
  pushMatrix();
  translate(g * width/25.5 - 24, height);
  scale(2.8);
  stroke(0);
  fill(175);
  rect(7, -12, 2, -4);
  beginShape(POLYGON);
  vertex(0, 0);
  vertex(10, 0);
  vertex(10, -10);
  vertex(12, -10);
  vertex(5, -15);
  vertex(-2, -10);
  vertex(0, -10);
  vertex(0, 0);
  endShape();
  rect(3, 0, 2, -5);
 popMatrix();
  }
}

void stop()
{
  // always close Minim audio classes when you finish with them
  song.close();
  super.stop();
}
